import React, { Component } from 'react';
import { getControl } from 'zorod/components/Zform/controls';
import { ZsearchListHOC } from 'zorod';
import api from '../Api';
import { Row, Col, Card, Form, Input, Button, message, Icon, Checkbox, Select, Cascader, Table, Popconfirm, Divider } from 'antd';
import DataDesenSetPop from '../popComponents/DataDesenSetPop'

const FormItem=Form.Item;
const TextArea=Input.TextArea;


class ecDesensitizationList extends Component {
	constructor(props) {
			super(props)
			this.state = {
				dataSource: [],
				selectedRowKeys: [], // Check here to configure the default column
				loading: false,
				popShow: true,
				popMode: '',
				popData: {},
				setMode: '',
				pagination: {},
				searchValues:  {"DATABASE_TYPE": "0"}
			}
	}

	// 页面加载函数
	componentDidMount() {
		api.system.getDestLists(1, 10, this.state.searchValues).then(res => {
			console.log(res)
			const pagination = { ...this.state.pagination }
			pagination.current = 1
			pagination.total = res.data.total
			this.setState({
				dataSource: res.data.list,
				pagination
			})
		})
	}
	//表单提交
	handelsubmit=()=>{
			let userInfo=this.props.form.getFieldsValue
			this.props.form.validateFields((err,values)=>{
						if(!err){
							console.log(values)
							message.success(`添加成功!!!`)
						}
			})
	}
	//取消
	handelConcel=()=>{
		this.setState({
			popShow: false
		})
	}
	// 关闭弹窗
	closePop = () => {
		this.setState({
			popShow: true
		})
	}
	// 打开新增弹窗
	sourceAdd = () => {
		this.setState({
			popShow: false,
			popMode: '新增脱敏规则',
			setMode: 'add',
			popData: {},
			detailMode: true
		})
	}
	// 打开更新弹窗
	sourceSet = (key) => {
		api.system.getSingleDest(key).then(res => {
			console.log(res)
			this.setState({
				popShow: false,
				popMode: '脱敏规则配置',
				setMode: 'update',
				popData: res.data,
				detailMode: true
			})
		})
	}
	// 打开详情窗口
	sourceDetailSet = (data) => {
		api.system.getSingleDest(data).then(res => {
			console.log(res)
			this.setState({
				popShow: false,
				popMode: '脱敏规则详情',
				setMode: '',
				popData: res.data,
				detailMode: false
			})
			
		})
	}
	// 新增一条数据
	addDataSource = (data) => {
		api.system.addDest(data).then(res => {
			this.setState({
				popShow: true
			})
			api.system.getDestLists(1, 10, this.state.searchValues).then(res => {
				const pagination = { ...this.state.pagination }
				pagination.current = 1
				pagination.total = res.data.total
				this.setState({
					dataSource: res.data.list,
					pagination
				})
			})
		})
	}
	// 修改一条数据
	updateDataSource = (id) => {
		api.system.updateDest(id).then(res => {
			console.log(res)
			this.setState({
				popShow: true
			})
			api.system.getDestLists(1, 10, this.state.searchValues).then(res => {
				const pagination = { ...this.state.pagination }
				pagination.current = 1
				pagination.total = res.data.total
				this.setState({
					dataSource: res.data.list,
					pagination
				})
			})
		})
	}
	// 删除一条数据
	deleteDataSource = (key) => {
		api.system.deleteDest(key).then(res => {
			console.log(res)
			api.system.getDestLists(1, 10, this.state.searchValues).then(res => {
				const pagination = { ...this.state.pagination }
				pagination.current = 1
				pagination.total = res.data.total
				this.setState({
					dataSource: res.data.list,
					pagination
				})
			})
		})
	}
	// 搜索
	search = () => {
		this.props.form.validateFields((err, values)=>{
			// values = JSON.stringify(values)
			console.log(values)
			this.setState({
				searchValues: values
			})
			api.system.getDestLists(1, 10, values).then(res => {
				const pagination = { ...this.state.pagination }
				pagination.current = 1
				pagination.total = res.data.total
				this.setState({
					dataSource: res.data.list,
					pagination
				})
			})
		})
	}
	// reload选项
	start = () => {
		this.setState({ loading: true })
		// ajax request after empty completing
		setTimeout(() => {
			this.setState({
				selectedRowKeys: [],
				loading: false,
			})
		}, 1000)
	}
	// 点击选择一行
  onSelectChange = selectedRowKeys => {
    console.log('selectedRowKeys changed: ', selectedRowKeys)
    this.setState({ selectedRowKeys })
  }
	// 点击翻页
	handleTableChange = pagination => {
		const pager = { ...this.state.pagination }
		pager.current = pagination.current
		this.setState({
			pagination: pager,
		})
		api.system.getDestLists( pagination.current, pagination.pageSize, this.state.searchValues).then(res => {
			console.log(res)
			const pagination = { ...this.state.pagination }
			pagination.total = res.data.total
			this.setState({
				dataSource: res.data.list,
        pagination
			})
		})
	}

	render() { 
		const { getFieldDecorator, getFieldsError, getFieldError, isFieldTouched } = this.props.form
		const formItemLayout = {
		    labelCol: { span: 8 },
		    wrapperCol: { span: 16 },
		  }
		const buttonItemLayout = {
						wrapperCol: { span: 14, offset: 4 },
					}
		const formTailLayout = {
			labelCol: { span: 12 },
			wrapperCol: { span: 12 },
		}
		const formButtom={
			wrapperCol: { span: 12, offset: 6 }
		}
		const columns = [
			{
				title: '脱敏规则',
				dataIndex: 'desenName',
				key: 'desenName',
			},
			{
				title: '脱敏类型',
				dataIndex: 'desenType',
				key: 'desenType',
				render (desenType) {
					let config = {
						'1': '替换',
						'2': '掩码',
						'3': '截断',
						'4': '重排',
						'5': '加密',
						'10': '自定义'
					}
					return config[desenType]
				}
			},
			{
				title: '执行类型',
				dataIndex: 'runType',
				key: 'runType',
				render (runType) {
					let config = {
						'0': 'JAVA任务方式',
						'1': '调用shell方式',
						'2': '调用sql方式'
					}
					return config[runType]
				}
			},
			{
				title: '操作',
				key: 'actions',
				width: '25%',
				render: (text, record) => (
					<div>						
						<Button icon='edit' type='primary' size='small' onClick={() => this.sourceSet(record.id)}>修改</Button><Divider type="vertical" />
						<Popconfirm placement="topLeft" title='是否确认删除？' onConfirm={() => this.deleteDataSource(record.id)} okText="确认" cancelText="取消">
							<Button icon='delete' type='danger' size='small'>删除</Button>
						</Popconfirm>
						<Divider type="vertical" /><Button icon='eye' type='default' size='small' onClick={() => this.sourceDetailSet(record.id)}>详情</Button>
					</div>
				)
			}
		]
    const { loading, selectedRowKeys } = this.state
    const rowSelection = {
      selectedRowKeys,
      onChange: this.onSelectChange,
    }
    const hasSelected = selectedRowKeys.length > 0
		return ( 
			<div>
				<div>
					
					<Card title="脱敏规则管理" extra={<div>
						<Button icon='plus' type='primary' onClick={this.sourceAdd}>新增</Button>
					</div>}>
						<FormItem label="脱敏规则" {...formItemLayout}
							style={{ display: 'inline-block', width: 'calc(35% - 12px)' }}
						>
							{
								getFieldDecorator('desenName', {
									rules: [
										{
											required: false,
											message: '单行输入',
										},
									],
								})
								(<Input placeholder="单行输入" />)
							}
						</FormItem>
						
						<FormItem label="脱敏类型" {...formItemLayout}
							style={{ display: 'inline-block', width: 'calc(35% - 12px)' }}
						>
							{getFieldDecorator('desenType', {
								initialValue: '-1',
								rules: [
									{
										required: false,
										message: '请输入脱敏类型',
									},
								],
							})(<Select style={{ width: 100 }}>
								<option value="-1">全部</option>
								<option value="1">替换</option>
								<option value="2">掩码</option>
								<option value="3">截断</option>
								<option value="4">重排</option>
								<option value="5">加密</option>
								<option value="10">自定义</option>
							</Select>)}
						</FormItem>
						
						<FormItem
							style={{ display: 'inline-block', width: 'calc(28% - 12px)' }}
						>
							<Button icon='search' onClick={this.search} type='primary'>搜索</Button>
						</FormItem>
						<Button type="primary" onClick={this.start} disabled={!hasSelected} loading={loading}>
							重置选择
						</Button>
						<span style={{ marginLeft: 8 }}>
							{hasSelected ? `Selected ${selectedRowKeys.length} items` : ''}
						</span>
						<Table
							rowSelection={rowSelection}
							pagination={this.state.pagination}
							loading={this.state.loading}
							onChange={this.handleTableChange}
							columns={columns}
							dataSource={this.state.dataSource}
						></Table>
					</Card>
					{!this.state.popShow &&
						<DataDesenSetPop
							title={this.state.popMode}
							onPopClose={this.closePop}
							onAdd={this.addDataSource}
							onUpdate={this.updateDataSource}
							data={this.state.popData}
							setMode={this.state.setMode}
							detailMode={this.state.detailMode}
						></DataDesenSetPop>
					}
				</div>
			</div>
		)
	}
}
export default Form.create({ name: 'ecDesensitizationList' })(ecDesensitizationList);
//export default EcTashAdd;