import React, { Component } from 'react';
import { getControl } from 'zorod/components/Zform/controls';
import { ZsearchListHOC } from 'zorod';
import api from '../Api';
import { Row, Col, Card, Form, Input, Button, message, Icon, Checkbox, Select, Cascader, Table, Popconfirm, Divider } from 'antd';
import TagBatchSetPop from '../popComponents/TagBatchSetPop'

const FormItem=Form.Item;
const TextArea=Input.TextArea;


class ecTagBatchList extends Component {
	constructor(props) {
			super(props)
			this.state = {
				dataSource: [],
				batchNameList: [],
				selectInitialValue: '',
				selectedRowKeys: [], // Check here to configure the default column
				loading: false,
				popShow: true,
				popMode: '',
				popData: {},
				setMode: '',
				pagination: {},
				searchValues: {"DATABASE_TYPE": "0"}
			}
	}

	// 页面加载函数
	componentDidMount() {
		api.system.getListTagBatch(1, 10, this.state.searchValues).then(res => {
			const pagination = { ...this.state.pagination }
			pagination.current = 1
			pagination.total = res.data.total
			for (let data of res.data.list) {
				data.STATUS = ['未运行', '正运行', '完成'][data.STATUS]
				data.RESULT = ['未有结果', '正常', '有错误', '有严重错误'][data.RESULT]
			}
			this.setState({
				dataSource: res.data.list,
				pagination
			})
		})
		api.system.getBatchLists(1, 999, {'MODULE_TYPE': 4}).then(res => {
			const batchNameList = []
			for (let data of res.data.list) {
				batchNameList.push({name: data.BATCH_NAME, id: data.BATCH_ID})
			}
			batchNameList.unshift({name: '全部', id: '0'})
			this.setState({
				batchNameList,
				selectInitialValue: batchNameList[0].id
			})
		})
	}
	//表单提交
	handelsubmit=()=>{
			let userInfo=this.props.form.getFieldsValue
			this.props.form.validateFields((err,values)=>{
						if(!err){
							console.log(values)
							message.success(`添加成功!!!`)
						}
			})
	}
	//取消
	handelConcel=()=>{
		this.setState({
			popShow: false
		})
	}
	// 关闭弹窗
	closePop = () => {
		this.setState({
			popShow: true
		})
	}
	// 打开新增弹窗
	sourceAdd = () => {
		this.setState({
			popShow: false,
			popMode: '新增标签生成任务',
			setMode: 'add',
			popData: {},
			detailMode: true
		})
	}
	// 打开更新弹窗
	sourceSet = (key) => {
		api.system.getSingleTagBatch(key).then(res => {
			console.log(res)
			this.setState({
				popShow: false,
				popMode: '标签生成任务配置',
				setMode: 'update',
				popData: res.data,
				detailMode: true
			})
		})
	}
	// 打开详情窗口
	sourceDetailSet = (key) => {
		api.system.getSingleTagBatch(key).then(res => {
			console.log(res)
			this.setState({
				popShow: false,
				popMode: '标签生成任务详情',
				setMode: '',
				popData: res.data,
				detailMode: false
			})
		})
	}
	// 新增一条数据
	addDataSource = (data) => {
		api.system.addTagBatch(data).then(res => {
			this.setState({
				popShow: true
			})
			api.system.getListTagBatch(1, 10, this.state.searchValues).then(res => {
				const pagination = { ...this.state.pagination }
				pagination.current = 1
				pagination.total = res.data.total
				for (let data of res.data.list) {
					data.STATUS = ['未运行', '正运行', '完成'][data.STATUS]
					data.RESULT = ['未有结果', '正常', '有错误', '有严重错误'][data.RESULT]
				}
				this.setState({
					dataSource: res.data.list,
					pagination
				})
			})
		})
	}
	// 修改一条数据
	updateDataSource = (data) => {
		api.system.updateTagBatch(data).then(res => {
			console.log(res)
			this.setState({
				popShow: true
			})
			api.system.getListTagBatch(1, 10, this.state.searchValues).then(res => {
				const pagination = { ...this.state.pagination }
				pagination.current = 1
				pagination.total = res.data.total
				for (let data of res.data.list) {
					data.STATUS = ['未运行', '正运行', '完成'][data.STATUS]
					data.RESULT = ['未有结果', '正常', '有错误', '有严重错误'][data.RESULT]
				}
				this.setState({
					dataSource: res.data.list,
					pagination
				})
			})
		})
	}
	// 删除一条数据
	deleteDataSource = (key) => {
		api.system.deleteTagBatch(key).then(res => {
			console.log(res)
			api.system.getListTagBatch(1, 10, this.state.searchValues).then(res => {
				const pagination = { ...this.state.pagination }
				pagination.current = 1
				pagination.total = res.data.total
				for (let data of res.data.list) {
					data.STATUS = ['未运行', '正运行', '完成'][data.STATUS]
					data.RESULT = ['未有结果', '正常', '有错误', '有严重错误'][data.RESULT]
				}
				this.setState({
					dataSource: res.data.list,
					pagination
				})
			})
		})
	}
	// 搜索
	search = () => {
		this.props.form.validateFields((err, values)=>{
			// values = JSON.stringify(values)
			console.log(values)
			this.setState({
				searchValues: values
			})
			api.system.getListTagBatch(1, 10, values).then(res => {
				const pagination = { ...this.state.pagination }
				pagination.current = 1
				pagination.total = res.data.total
				for (let data of res.data.list) {
					data.STATUS = ['未运行', '正运行', '完成'][data.STATUS]
					data.RESULT = ['未有结果', '正常', '有错误', '有严重错误'][data.RESULT]
				}
				this.setState({
					dataSource: res.data.list,
					pagination
				})
			})
		})
	}
	// reload选项
	start = () => {
		this.setState({ loading: true })
		// ajax request after empty completing
		setTimeout(() => {
			this.setState({
				selectedRowKeys: [],
				loading: false,
			})
		}, 1000)
	}
	// 点击选择一行
  onSelectChange = selectedRowKeys => {
    console.log('selectedRowKeys changed: ', selectedRowKeys)
    this.setState({ selectedRowKeys })
  }
	// 点击翻页
	handleTableChange = pagination => {
		const pager = { ...this.state.pagination }
		pager.current = pagination.current
		this.setState({
			pagination: pager,
		})
		api.system.getListTagBatch( pagination.current, pagination.pageSize, this.state.searchValues).then(res => {
			const pagination = { ...this.state.pagination }
			for (let data of res.data.list) {
				data.STATUS = ['未运行', '正运行', '完成'][data.STATUS]
				data.RESULT = ['未有结果', '正常', '有错误', '有严重错误'][data.RESULT]
			}
			this.setState({
				dataSource: res.data.list,
        pagination
			})
		})
	}

	render() { 
		const { getFieldDecorator, getFieldsError, getFieldError, isFieldTouched } = this.props.form
		const { batchNameList, selectInitialValue } = this.state
		const formItemLayout = {
		    labelCol: { span: 8 },
		    wrapperCol: { span: 16 },
		  }
		const buttonItemLayout = {
						wrapperCol: { span: 14, offset: 4 },
					}
		const formTailLayout = {
			labelCol: { span: 12 },
			wrapperCol: { span: 12 },
		}
		const formButtom={
			wrapperCol: { span: 12, offset: 6 }
		}
		const columns = [
			{
				title: '批次名称',
				dataIndex: 'BATCH_NAME',
				key: 'BATCH_NAME'
			},
			{
				title: '规则名称',
				dataIndex: 'sysODSTagRuleDo.RULE_NAME',
				key: 'sysODSTagRuleDo.RULE_NAME'
			},
			{
				title: '运行状态',
				dataIndex: 'STATUS',
				key: 'STATUS'
			},
			{
				title: '结果状态',
				dataIndex: 'RESULT',
				key: 'RESULT'
			},
			{
				title: '操作',
				key: 'actions',
				render: (text, record) => (
					<div>
						<Button icon='eye' type='default' size='small' onClick={() => this.sourceDetailSet(record.id)}>详情</Button><Divider type="vertical" />
						<Button icon='edit' type='primary' size='small' onClick={() => this.sourceSet(record.id)}>修改</Button><Divider type="vertical" />
						<Popconfirm placement="topLeft" title='是否确认删除？' onConfirm={() => this.deleteDataSource(record.id)} okText="确认" cancelText="取消">
							<Button icon='delete' type='danger' size='small'>删除</Button>
						</Popconfirm>
					</div>
				)
			}
		]
    const { loading, selectedRowKeys } = this.state
    const rowSelection = {
      selectedRowKeys,
      onChange: this.onSelectChange,
    }
    const hasSelected = selectedRowKeys.length > 0
		return ( 
			<div>
				<div>
					<Card title="生成任务配置" extra={<div>
						<Button icon='plus' type='primary' onClick={this.sourceAdd}>新增</Button>
					</div>}>
						<FormItem label="批次名" {...formItemLayout}
							style={{ display: 'inline-block', width: 'calc( 30% - 12px )' }}
						>
							{
								getFieldDecorator('BATCH_ID', {
									initialValue: '0',
									rules: [
										{
											required: false,
											message: '请输入批次名',
										},
									],
								})
								(<Select
									style={{ width: '150px' }}
									showSearch
									optionFilterProp="children"
									filterOption={(input, option) =>
										option.props.children.toLowerCase().indexOf(input.toLowerCase()) >= 0
									}
								>
									{batchNameList.map((data) => (
										<option value={data.id}>{data.name}</option>
									))}
								</Select>)
							}
						</FormItem>
						<FormItem label="运行状态" {...formItemLayout}
							style={{ display: 'inline-block', width: 'calc( 30% - 12px )' }}
						>
							{getFieldDecorator('STATUS', {
								initialValue: '-1',
								rules: [
									{
										required: false,
										message: '请输入运行状态',
									},
								],
							})(<Select style={{ width: 100 }}>
								<option value="-1">全部</option>
								<option value="0">未运行</option>
								<option value="1">正运行</option>
								<option value="2">已完成</option>
							</Select>)}
						</FormItem>
						<FormItem label="运行结果" {...formItemLayout}
							style={{ display: 'inline-block', width: 'calc( 30% - 12px )' }}
						>
							{getFieldDecorator('RESULT', {
								initialValue: '-1',
								rules: [
									{
										required: false,
										message: '请输入运行结果',
									},
								],
							})(<Select style={{ width: 100 }}>
								<option value="-1">全部</option>
								<option value="0">未有结果</option>
								<option value="1">正常</option>
								<option value="2">不正常</option>
								<option value="3">严重不正常</option>
							</Select>)}
						</FormItem>
						<FormItem
							style={{ display: 'inline-block', width: 'calc(10% - 12px)' }}
						>
							<Button icon='search' onClick={this.search} type='primary'>搜索</Button>
						</FormItem>
						<Button type="primary" onClick={this.start} disabled={!hasSelected} loading={loading}>
							重置选择
						</Button>
						<span style={{ marginLeft: 8 }}>
							{hasSelected ? `Selected ${selectedRowKeys.length} items` : ''}
						</span>
						<Table
							rowSelection={rowSelection}
							pagination={this.state.pagination}
							loading={this.state.loading}
							onChange={this.handleTableChange}
							columns={columns}
							dataSource={this.state.dataSource}
						></Table>
					</Card>
					{!this.state.popShow &&
						<TagBatchSetPop
							title={this.state.popMode}
							onPopClose={this.closePop}
							onAdd={this.addDataSource}
							onUpdate={this.updateDataSource}
							data={this.state.popData}
							setMode={this.state.setMode}
							detailMode={this.state.detailMode}
						></TagBatchSetPop>
					}
				</div>
			</div>
		)
	}
}
export default Form.create({ name: 'ecTagBatchList' })(ecTagBatchList);
//export default EcTashAdd;