import React from 'react'
import { Card, Form, Input, Button, message, Icon, Checkbox, Select, Cascader, DatePicker } from 'antd';
require('./assets/TaskSelect.css')

const FormItem=Form.Item;
const TextArea=Input.TextArea;

const formItemLayout = {
    labelCol: { span: 4 },
    wrapperCol: { span: 14 },
  };
  const formTailLayout = {
    labelCol: { span: 4 },
    wrapperCol: { span: 12, offset: 4 },
  };
  const formButtom={
    wrapperCol: { span: 12, offset: 6 }
  }
const residences=["baijing","hunian","guangxi"];

class DataDesenSetPop extends React.Component {
	constructor(props) {
		super(props)
		this.state = {
			setMode: this.props.setMode,
			title: this.props.title,
			databaseType: '0',
			data: this.props.data,
			detailMode: this.props.detailMode
		}
	}
	close = () => {
		this.props.onPopClose()
	}
	handelsubmit = () => {
		this.props.form.validateFields((err, values)=>{
			if (this.state.setMode === 'add') {
				this.props.onAdd(values)
			} else if (this.state.setMode === 'update') {
				values.id = this.state.data.id
				this.props.onUpdate(values)
			}
		})
	}
	handelConnectTest = () => {
		
	}
	
	render() {
		const { getFieldDecorator, getFieldsError, getFieldError, isFieldTouched } = this.props.form
		const { data } = this.state
		return (
			<div>
				<div className='mask'></div>
				<div className='wrap'>
					<div className='topbar'>
						<div className='close' onClick={this.close}>x</div>
					</div>
					<div className='content'>
						<Card title={this.state.title}>
							<Form layout='horizontal'>
								
								<FormItem label="规则名称" {...formItemLayout}>
									{
										getFieldDecorator('desenName', {
											initialValue: data.desenName,
											rules: [
												{
													required: true,
													message: '请输入规则名称',
												},
											],
										})
										(<Input placeholder="请输入规则名称" />)
									}
								</FormItem>
								
								
								
								<FormItem label="脱敏类型" {...formItemLayout}>
									{getFieldDecorator('desenType', {
										initialValue: data.desenType ? data.desenType + '' : '-1',
										rules: [
											{
												required: false,
												message: 'Please select your habitual residence!'
											},
										],
									})(<Select>
										<option value="-1">全部</option>
										<option value="1">替换</option>
										<option value="2">掩码</option>
										<option value="3">截断</option>
										<option value="4">重排</option>
										<option value="5">加密</option>
										<option value="10">自定义</option>
									</Select>)}
								</FormItem>
								<FormItem label="脱敏参数" {...formItemLayout}>
									{
										getFieldDecorator('desenParamFormat', {
											initialValue: data.desenParamFormat,
											rules: [
												{
													required: false,
													message: '请输入脱敏参数',
												},
											],
										})
										(<Input placeholder="请输入脱敏参数" />)
									}
								</FormItem>
								
								<FormItem label="执行类型" {...formItemLayout}>
									{getFieldDecorator('runType', {
										initialValue: data.runType ? data.runType : '0',
										rules: [
											{
												required: true,
												message: 'Please select your habitual residence!'
											},
										],
									})(<Select>
										<option value="0">JAVA任务方式</option>
										<option value="1">调用shell方式</option>
										<option value="2">调用sql方式</option>
									</Select>)}
								</FormItem>
								
								<FormItem label="执行地址" {...formItemLayout}>
									{
										getFieldDecorator('apiUrl', {
											initialValue: data.apiUrl,
											rules: [
												{
													required: false,
													message: '请输入执行地址',
												},
											],
										})
										(<Input placeholder="请输入执行地址" />)
									}
								</FormItem>
								
								<FormItem label="描述" {...formItemLayout}>
									{
										getFieldDecorator('describe', {
											initialValue: data.describe,
											rules: [
												{
													required: false,
													message: '描述',
												},
											],
										})
										(<Input placeholder="描述" />)
									}
								</FormItem>
								
								
								
								{/* {!this.state.detailMode && <div>
									<FormItem label="运行状态" {...formItemLayout}>
										{getFieldDecorator('STATUS', {
										initialValue: data.STATUS ? data.STATUS : '0',
											rules: [
												{
													required: false,
													message: 'Please select your habitual residence!'
												},
											],
										})(<Select>
											<option value="0">未运行</option>
											<option value="1">正运行</option>
											<option value="2">已完成</option>
										</Select>)}
									</FormItem>
								
									<FormItem label="运行结果" {...formItemLayout}>
										{getFieldDecorator('RESULT', {
										initialValue: data.RESULT ? data.RESULT : '0',
											rules: [
												{
													required: false,
													message: 'Please select your habitual residence!'
												},
											],
										})(<Select>
											<option value="0">未有结果</option>
											<option value="1">正常</option>
											<option value="2">不正常</option>
											<option value="3">严重不正常</option>
										</Select>)}
									</FormItem>
								</div>} */}
								
								<FormItem  {...formButtom}>            
									<Button type='primary' onClick={this.handelsubmit}>保存</Button>&nbsp;&nbsp;&nbsp;&nbsp;
									<Button type='danger' onClick={this.close}>取消</Button>
								</FormItem>
								
							</Form>
						</Card>
					</div>
				</div>
			</div>
		)
	}
}

export default Form.create({ name: 'DataDesenSetPop' })(DataDesenSetPop);