import React from 'react'
import { getControl } from 'zorod/components/Zform/controls';
import { ZsearchListHOC } from 'zorod';
import api from '../Api';
import { Card, Form, Input, Button, message, Icon, Checkbox, Select, Cascader, DatePicker, Radio,Switch } from 'antd';
require('./assets/TaskSelect.css')

const FormItem=Form.Item;
const TextArea=Input.TextArea;

const formItemLayout = {
    labelCol: { span: 4 },
    wrapperCol: { span: 14 },
  };
  const formTailLayout = {
    labelCol: { span: 4 },
    wrapperCol: { span: 12, offset: 4 },
  };
  const formButtom={
    wrapperCol: { span: 12, offset: 6 }
  }
const residences=["baijing","hunian","guangxi"];

class DataDesenexamineTPop extends React.Component {
	constructor(props) {
		super(props)
		this.state = {
			setMode: this.props.setMode,
			title: this.props.title,
			databaseType: '0',
			data: this.props.data,
			detailMode: this.props.detailMode,
			radioMode: 'select',
			dataSource: [],
			selectInitialValue: '',
			dataSource2: [],
			select2InitialValue: '',
			dataSource3: [],
			select3InitialValue: '',
		}
	}
	
	// 页面加载函数
	componentDidMount() {
		api.system.getTableLists(1, 999, {"DATABASE_TYPE": "5"}).then(res => {
			var dataBaseId = []
			for (let data of res.data.list) {
				dataBaseId.push({name: data.RULE_NAME, id: data.id})
			}
			this.setState({
				dataSource2: dataBaseId,
				select2InitialValue: dataBaseId[0].id
			})
		})
		api.system.getBatchLists(1, 999, {'MODULE_TYPE': 5}).then(res => {
			var dataBaseId = []
			for (let data of res.data.list) {
				dataBaseId.push({name: data.BATCH_NAME, id: data.BATCH_ID})
			}
			this.setState({
				dataSource3: dataBaseId,
				select3InitialValue: dataBaseId[0].id
			})
		})
	}
	close = () => {
		this.props.onPopClose()
	}
	handelsubmit = () => {
		this.props.form.validateFields((err, values)=>{
			// if (values.batchId) {
			// 	for (let data of this.state.dataSource3) {
			// 		if (data.id === values.batchId) {
			// 			values.taskName = data.name
			// 		}
			// 	}
			// }
			if (this.state.setMode === 'add') {
				this.props.onAdd(values)
			} else if (this.state.setMode === 'update') {
				values.id = this.state.data.id
				this.props.onUpdate(values)
			}else if (this.state.setMode === 'Examine') {
				values.id = this.state.data.id
				this.props.onExamine(values)
			}
		})
	}
	handelConnectTest = () => {
		
	}
	handleSizeChange = e => {
	  this.setState({
			radioMode: e.target.value,
			select3InitialValue: ''
		})
	}
	
	render() {
		const { getFieldDecorator, getFieldsError, getFieldError, isFieldTouched } = this.props.form
		const { data, dataSource, selectInitialValue, dataSource2, select2InitialValue, dataSource3, select3InitialValue, radioMode } = this.state
		return (
			<div>
				<div className='mask'></div>
				<div className='wrap'>
					<div className='topbar'>
						<div className='close' onClick={this.close}>x</div>
					</div>
					<div className='content'>
						<Card title={this.state.title}>
							<Form layout='horizontal'>
							
								

						
							{/* <FormItem label="表字段" {...formItemLayout}>
									{
										getFieldDecorator('tableDo.TABLE_NAME_CN', {
											initialValue: data.tableDo.TABLE_NAME_CN,
											rules: [
												{
													required: false,
													message: '',
												},
											],
										})
										(<Input placeholder="" />)
									}
								</FormItem> */}
								
								
								
							 
								<FormItem label="审核" {...formItemLayout}>
								{
										getFieldDecorator('val', {
											initialValue:  false,
											rules: [
												{
													required: false,
													message: '',
												},
											],
										})
										(<Switch defaultChecked={this.state.data.verify == '1'?true:false}  />)
									}
								</FormItem>  							
								
								<FormItem label="描述" {...formItemLayout} style={{display:'none'}}>
									{
										getFieldDecorator('id', {
											initialValue: this.state.data.id,
											rules: [
												{
													required: false,
													message: '描述',
												},
											],
										})
										(<Input placeholder="描述" />)
									}
								</FormItem>
							
								
								<FormItem  {...formButtom}>            
									<Button type='primary' onClick={this.handelsubmit}>保存</Button>&nbsp;&nbsp;&nbsp;&nbsp;
									<Button type='danger' onClick={this.close}>取消</Button>
								</FormItem>
								
							</Form>
						</Card>
					</div>
				</div>
			</div>
		)
	}
}

export default Form.create({ name: 'DataDesenexamineTPop' })(DataDesenexamineTPop);