import React from 'react'
import { getControl } from 'zorod/components/Zform/controls';
import { ZsearchListHOC } from 'zorod';
import api from '../Api';
import { Card, Form, Input, Button, message, Icon, Checkbox, Select, Cascader, DatePicker } from 'antd';
require('./assets/TaskSelect.css')

const FormItem=Form.Item;
const TextArea=Input.TextArea;

const formItemLayout = {
    labelCol: { span: 4 },
    wrapperCol: { span: 14 },
  };
  const formTailLayout = {
    labelCol: { span: 4 },
    wrapperCol: { span: 12, offset: 4 },
  };
  const formButtom={
    wrapperCol: { span: 12, offset: 6 }
  }
const residences=["baijing","hunian","guangxi"];

class StandardCodeSetPop extends React.Component {
	constructor(props) {
		super(props)
		this.state = {
			setMode: this.props.setMode,
			title: this.props.title,
			databaseType: '0',
			data: this.props.data,
			dataSource: [],
			selectInitialValue: ''
		}
	}
	
	// 页面加载函数
	componentDidMount() {
		api.system.getListStdcodeType(1, 999, {"DATABASE_TYPE": "0"}).then(res => {
			var dataBaseId = []
			for (let data of res.data.list) {
				dataBaseId.push({name: data.TYPE_NAME, id: data.ID})
			}
			this.setState({
				dataSource: dataBaseId,
				selectInitialValue: dataBaseId[0].id
			})
		})
	}
	close = () => {
		this.props.onPopClose()
	}
	handelsubmit = () => {
		this.props.form.validateFields((err, values)=>{
			if (this.state.setMode === 'add') {
				this.props.onAdd(values)
			} else if (this.state.setMode === 'update') {
				values.id = this.state.data.id
				this.props.onUpdate(values)
			}
		})
	}
	handelConnectTest = () => {
		
	}
	
	render() {
		const { getFieldDecorator, getFieldsError, getFieldError, isFieldTouched } = this.props.form
		const { data } = this.state
		return (
			<div>
				<div className='mask'></div>
				<div className='wrap'>
					<div className='topbar'>
						<div className='close' onClick={this.close}>x</div>
					</div>
					<div className='content'>
						<Card title={this.state.title}>
							<Form layout='horizontal'>
								<FormItem label="标准码类型" {...formItemLayout}>
									{
										getFieldDecorator('codeType.TYPE_NAME', {
											initialValue: data.codeType.TYPE_NAME,
											rules: [
												{ required: false, message: 'Please select your habitual residence!' },
											],
										})(<Input placeholder="请输入标准码类型" />)
									}
								</FormItem>
								
								<FormItem label="标准码ID" {...formItemLayout}>
									{
										getFieldDecorator('STANDARD_CODE_ID', {
											initialValue: data.STANDARD_CODE_ID,
											rules: [
												{
													required: true,
													message: '请输入标准码ID',
												},
											],
										})
										(<Input placeholder="请输入标准码ID" />)
									}
								</FormItem>
								
								<FormItem label="标准码名称" {...formItemLayout}>
									{
										getFieldDecorator('STANDARD_CODE', {
											initialValue: data.STANDARD_CODE,
											rules: [
												{
													required: false,
													message: '请输入标准码名称',
												},
											],
										})
										(<Input placeholder="请输入标准码名称" />)
									}
								</FormItem>
								
								<FormItem label="标准码标号" {...formItemLayout}>
									{
										getFieldDecorator('STANDARD_NO', {
											initialValue: data.STANDARD_NO,
											rules: [
												{
													required: false,
													message: '请输入标准码标号',
												},
											],
										})
										(<Input placeholder="请输入标准码标号" />)
									}
								</FormItem>
								
								<FormItem label="说明" {...formItemLayout}>
									{
										getFieldDecorator('STANDARD_CODE_DESC', {
											initialValue: data.STANDARD_CODE_DESC,
											rules: [
												{
													required: false,
													message: '请输入说明',
												},
											],
										})
										(<Input placeholder="请输入说明" />)
									}
								</FormItem>
							
								{/* <FormItem  {...formButtom}>            
									<Button type='primary' onClick={this.handelsubmit}>保存</Button>&nbsp;&nbsp;&nbsp;&nbsp;
									<Button type='danger' onClick={this.close}>取消</Button>
								</FormItem> */}
								
							</Form>
						</Card>
					</div>
				</div>
			</div>
		)
	}
}

export default Form.create({ name: 'StandardCodeSetPop' })(StandardCodeSetPop);