import React from 'react'
import { Card, Form, Input, Button, message, Icon, Checkbox, Select, Cascader, DatePicker } from 'antd';
require('./assets/TaskSelect.css')

const FormItem=Form.Item;
const TextArea=Input.TextArea;

const formItemLayout = {
    labelCol: { span: 4 },
    wrapperCol: { span: 14 },
  };
  const formTailLayout = {
    labelCol: { span: 4 },
    wrapperCol: { span: 12, offset: 4 },
  };
  const formButtom={
    wrapperCol: { span: 12, offset: 6 }
  }
const residences=["baijing","hunian","guangxi"];

class TagRuleSetPop extends React.Component {
	constructor(props) {
		super(props)
		this.state = {
			setMode: this.props.setMode,
			title: this.props.title,
			databaseType: '0',
			data: this.props.data,
			detailMode: this.props.detailMode
		}
	}
	close = () => {
		this.props.onPopClose()
	}
	handelsubmit = () => {
		this.props.form.validateFields((err, values)=>{
			if (this.state.setMode === 'add') {
				this.props.onAdd(values)
			} else if (this.state.setMode === 'update') {
				values.id = this.state.data.id
				this.props.onUpdate(values)
			}
		})
	}
	handelConnectTest = () => {
		
	}
	
	render() {
		const { getFieldDecorator, getFieldsError, getFieldError, isFieldTouched } = this.props.form
		const { data } = this.state
		return (
			<div>
				<div className='mask'></div>
				<div className='wrap'>
					<div className='topbar'>
						<div className='close' onClick={this.close}>x</div>
					</div>
					<div className='content'>
						<Card title={this.state.title}>
							<Form layout='horizontal'>
								
								<FormItem label="规则名称" {...formItemLayout}>
									{
										getFieldDecorator('RULE_NAME', {
											initialValue: data.RULE_NAME,
											rules: [
												{
													required: true,
													message: '请输入规则名称',
												},
											],
										})
										(<Input placeholder="请输入规则名称" />)
									}
								</FormItem>
								
								<FormItem label="任务描述" {...formItemLayout}>
									{
										getFieldDecorator('DESCRIBE', {
											initialValue: data.DESCRIBE,
											rules: [
												{
													required: false,
													message: '请输入任务描述',
												},
											],
										})
										(<Input placeholder="请输入任务描述" />)
									}
								</FormItem>
								
								<FormItem label="标签类型" {...formItemLayout}>
									{getFieldDecorator('TAG_TYPE', {
										initialValue: data.TAG_TYPE ? data.TAG_TYPE : '1',
										rules: [
											{
												required: false,
												message: 'Please select your habitual residence!'
											},
										],
									})(<Select>
										<option value="1">基础标签</option>
										<option value="2">模型标签</option>
										<option value="3">趋势标签</option>
									</Select>)}
								</FormItem>
								
								<FormItem label="任务类型" {...formItemLayout}>
									{getFieldDecorator('RULE_TASH_TYPE', {
										initialValue: data.RULE_TASH_TYPE ? data.RULE_TASH_TYPE : '0',
										rules: [
											{
												required: true,
												message: 'Please select your habitual residence!'
											},
										],
									})(<Select>
										<option value="0">JAVA任务方式</option>
										<option value="1">调用shell方式</option>
										<option value="2">调用sql方式</option>
									</Select>)}
								</FormItem>
								
								<FormItem label="API_URL" {...formItemLayout}>
									{
										getFieldDecorator('API_URL', {
											initialValue: data.API_URL,
											rules: [
												{
													required: false,
													message: '请输入API_URL',
												},
											],
										})
										(<Input placeholder="请输入API_URL" />)
									}
								</FormItem>
								
								<FormItem label="API参数" {...formItemLayout}>
									{
										getFieldDecorator('TRANS_PARAM_FORMAT', {
											initialValue: data.TRANS_PARAM_FORMAT,
											rules: [
												{
													required: false,
													message: '请输入API参数',
												},
											],
										})
										(<Input placeholder="请输入API参数" />)
									}
								</FormItem>
								
								<FormItem label="SQL" {...formItemLayout}>
									{
										getFieldDecorator('SQL', {
											initialValue: data.SQL,
											rules: [
												{
													required: false,
													message: '请输入SQL',
												},
											],
										})
										(<Input placeholder="请输入SQL" />)
									}
								</FormItem>
								
								{!this.state.detailMode && <div>
									<FormItem label="运行状态" {...formItemLayout}>
										{getFieldDecorator('STATUS', {
										initialValue: data.STATUS ? data.STATUS : '0',
											rules: [
												{
													required: false,
													message: 'Please select your habitual residence!'
												},
											],
										})(<Select>
											<option value="0">未运行</option>
											<option value="1">正运行</option>
											<option value="2">已完成</option>
										</Select>)}
									</FormItem>
								
									<FormItem label="运行结果" {...formItemLayout}>
										{getFieldDecorator('RESULT', {
										initialValue: data.RESULT ? data.RESULT : '0',
											rules: [
												{
													required: false,
													message: 'Please select your habitual residence!'
												},
											],
										})(<Select>
											<option value="0">未有结果</option>
											<option value="1">正常</option>
											<option value="2">不正常</option>
											<option value="3">严重不正常</option>
										</Select>)}
									</FormItem>
								</div>}
								
								<FormItem  {...formButtom} style={{ display: this.state.setMode ? 'block' : 'none' }}>
									<Button type='primary' onClick={this.handelsubmit}>保存</Button>&nbsp;&nbsp;&nbsp;&nbsp;
									<Button type='danger' onClick={this.close}>取消</Button>
								</FormItem>
								
							</Form>
						</Card>
					</div>
				</div>
			</div>
		)
	}
}

export default Form.create({ name: 'TagRuleSetPop' })(TagRuleSetPop);